// /*
//  * Created on May 1st 2023
//  *
//  * Copyright (C) 2023 Welltested AI - All Rights Reserved
//  * The code in this file is Intellectutal Property of Welltested AI.
//  * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
//  */
// import 'package:analyzer/dart/constant/value.dart';
// import 'package:analyzer/dart/element/element.dart';
// import 'package:analyzer/dart/element/type.dart';
// import 'package:analyzer/dart/element/visitor.dart';
// // import 'package:source_gen/source_gen.dart';

// class TypeVisitor extends RecursiveElementVisitor<void> {
//   final elements = <Element>{};

//   final DartType _futureType;

//   TypeVisitor(this._futureType);

//   @override
//   void visitClassElement(ClassElement element) {
//     elements.add(element);
//     super.visitClassElement(element);
//   }

//   @override
//   void visitEnumElement(EnumElement element) {
//     elements.add(element);
//     super.visitEnumElement(element);
//   }

//   @override
//   void visitFieldElement(FieldElement element) {
//     _addType(element.type);
//     super.visitFieldElement(element);
//   }

//   @override
//   void visitMethodElement(MethodElement element) {
//     _addType(element.returnType);
//     super.visitMethodElement(element);
//   }

//   @override
//   void visitMixinElement(MixinElement element) {
//     elements.add(element);
//     super.visitMixinElement(element);
//   }

//   @override
//   void visitParameterElement(ParameterElement element) {
//     _addType(element.type);
//     if (element.hasDefaultValue) {
//       _addTypesFromConstant(element.computeConstantValue()!);
//     }
//     super.visitParameterElement(element);
//   }

//   @override
//   void visitTypeParameterElement(TypeParameterElement element) {
//     _addType(element.bound);
//     super.visitTypeParameterElement(element);
//   }

//   @override
//   void visitTypeAliasElement(TypeAliasElement element) {
//     elements.add(element);
//     super.visitTypeAliasElement(element);
//   }

//   /// Adds [type] to the collected [elements].
//   void _addType(DartType? type) {
//     if (type == null) return;

//     if (type is InterfaceType) {
//       final alreadyVisitedElement = elements.contains(type.element);
//       elements.add(type.element);
//       type.typeArguments.forEach(_addType);
//       if (!alreadyVisitedElement) {
//         type.element.typeParameters.forEach(visitTypeParameterElement);

//         final toStringMethod =
//             type.element.lookUpMethod('toString', type.element.library);
//         if (toStringMethod != null && toStringMethod.parameters.isNotEmpty) {
//           // In a Fake class which implements a class which overrides `toString`
//           // with additional (optional) parameters, we must also override
//           // `toString` and reference the same types referenced in those
//           // parameters.
//           for (final parameter in toStringMethod.parameters) {
//             final parameterType = parameter.type;
//             if (parameterType is InterfaceType) {
//               parameterType.element.accept(this);
//             }
//           }
//         }
//       }
//       if (type.isDartAsyncFutureOr) {
//         // For some methods which return `FutureOr`, we need a dummy `Future`
//         // subclass and value.
//         _addType(_futureType);
//       }
//     } else if (type is FunctionType) {
//       _addType(type.returnType);

//       // [RecursiveElementVisitor] does not "step out of" the element model,
//       // into types, while traversing, so we must explicitly traverse [type]
//       // here, in order to visit contained elements.
//       for (var typeParameter in type.typeFormals) {
//         typeParameter.accept(this);
//       }
//       for (var parameter in type.parameters) {
//         parameter.accept(this);
//       }
//       var aliasElement = type.alias?.element;
//       if (aliasElement != null) {
//         elements.add(aliasElement);
//       }
//     }
//   }

//   void _addTypesFromConstant(DartObject object) {
//     final constant = ConstantReader(object);
//     if (constant.isNull ||
//         constant.isBool ||
//         constant.isInt ||
//         constant.isDouble ||
//         constant.isString ||
//         constant.isType) {
//       // No types to add from a literal.
//       return;
//     } else if (constant.isList) {
//       for (var element in constant.listValue) {
//         _addTypesFromConstant(element);
//       }
//     } else if (constant.isSet) {
//       for (var element in constant.setValue) {
//         _addTypesFromConstant(element);
//       }
//     } else if (constant.isMap) {
//       for (var pair in constant.mapValue.entries) {
//         _addTypesFromConstant(pair.key!);
//         _addTypesFromConstant(pair.value!);
//       }
//     } else if (object.toFunctionValue() != null) {
//       elements.add(object.toFunctionValue()!);
//     } else {
//       // If [constant] is not null, a literal, or a type, then it must be an
//       // object constructed with `const`. Revive it.
//       var revivable = constant.revive();
//       for (var argument in revivable.positionalArguments) {
//         _addTypesFromConstant(argument);
//       }
//       for (var pair in revivable.namedArguments.entries) {
//         _addTypesFromConstant(pair.value);
//       }
//       _addType(object.type);
//     }
//   }
// }
